﻿B4i=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.3
@EndOfDesignText@
'Code module

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'Public variables can be accessed from all modules.

	Dim LocManager As LocationManager
	
	Private pg As Page
	Private lblAccuracy As Label
	Private lblAltitude As Label
	Private lblBearing As Label
	Private lblEnable As Label
	Private lblHeading As Label
	Private lblLL As Label
	Private lblSpeed As Label
	Private lblTime As Label

End Sub

Sub Show

	If pg.IsInitialized = False Then
		pg.Initialize("pg")
		pg.RootPanel.Color = Colors.White
		pg.RootPanel.LoadLayout("gps")
	End If
	Main.NavControl.ShowPage(pg)

	LocManager.Initialize("LocManager")
	
	StartLocationUpdates
	
End Sub

Private Sub pg_Disappear
	
End Sub

Private Sub pg_Appear
	
End Sub

Private Sub pg_Resize (Width As Float, Height As Float)
	'Misc.HD.ToastMessageShow("pageGPS_Resize",False)
End Sub

Private Sub LocManager_AuthorizationStatusChanged (Status As Int)
	lblEnable.Visible = (LocManager.AuthorizationStatus = LocManager.AUTHORIZATION_DENIED _
		Or LocManager.AuthorizationStatus = LocManager.AUTHORIZATION_RESTRICTED)
	StartLocationUpdates
End Sub

Private Sub StartLocationUpdates
	'if the user allowed us to use the location service or if we never asked the user before then we call LocationManager.Start.
	If LocManager.IsAuthorized Or LocManager.AuthorizationStatus = LocManager.AUTHORIZATION_NOT_DETERMINED Then
		LocManager.Start(0)
	End If
	LocManager.StartHeading
End Sub

Private Sub LocManager_HeadingChanged (MagneticHeading As Double, TrueHeading As Double)
	If TrueHeading >= 0 Then
		lblHeading.Text = NumberFormat(TrueHeading, 1, 0) & Chr(176) & " (true north)"
	Else
		lblHeading.Text = NumberFormat(MagneticHeading, 1, 0) & Chr(176) & " (magnetic)"
	End If
	
End Sub
Sub LocManager_AllowCalibration As Boolean
	Return False
End Sub

Private Sub LocManager_LocationError
	Log("Error: " & LastException.Description)
End Sub

Private Sub LocManager_LocationChanged (Location1 As Location)
	If Location1.VerticalAccuracy >= 0 Then
		lblAltitude.Text =	NumberFormat(Location1.Altitude, 1, 1) & "m"
	Else
		lblAltitude.Text = "N/A"
	End If
	lblBearing.Text = Misc.ValueOrNA (Location1.Bearing, 1, Chr(176))
	If Location1.Accuracy >= 0 Then
		lblLL.Text = NumberFormat(Location1.Latitude, 2, 4) & " / " & NumberFormat(Location1.Longitude, 2, 4)
	Else
		lblLL.Text = "N/A"
	End If
	lblSpeed.Text = Misc.ValueOrNA(Location1.Speed, 1, "m/s")
	lblTime.Text = DateTime.Time(Location1.Time)
	lblAccuracy.Text = Misc.ValueOrNA(Location1.Accuracy, 2, "m")
End Sub
